Searching for HTTP Proxy by Organization/Location is wrong in certain cases with Any Organization
and Any Location

02/19/2020 04:10 PM - lan Ballou

Status: Closed

Priority: Normal

Assignee: lan Ballou

Category: Organizations and Locations

Target version:

Difficulty: Fixed in Releases: 2.1.0
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p

ull/7458
Description

All errors appear with Any Organization and Any Location are selected on top.
The following searches erroneously lists all proxies:

1) location= "Default Location"

2) organization= "Default Organization"

3) location= "Default Organization"

4) organization= "Default Location"

Note that these errors occur only for Default Organization/Location.

Numbers 3) and 4) are interesting because they are in the suggested filter drop down but do not make sense.

There seems to be some kind of mixing of organization and location since the following search works if "My Custom Organization" is
attached to some HTTP Proxy:

location= "My Custom Organization" -> Lists only the HTTP Proxy that belongs to "My Custom Organization"

Related issues:
Blocked by Katello - Bug #29142: Delete all http proxies in test setup Closed

Associated revisions

Revision aObbfb28 - 02/24/2020 10:31 PM - lan Ballou
Fixes #29070 - HTTP Proxy taxonomy searching incorrect

History

#1 - 02/19/2020 04:31 PM - lan Ballou

It appears that the mixing of Organizations and Locations in the filter suggestion drop down occurs regardless of the global organization and location.
This issue also occurs outside of HTTP Proxies (like with Domains), so it seems to be a separate problem with Foreman.

#2 - 02/19/2020 04:43 PM - lan Ballou

- Project changed from Katello to Foreman

#3 - 02/19/2020 05:38 PM - lan Ballou

The results are the same if searching with the v2 APl as well. Querying
https://admin:changeme@centos7-katello-devel-stable.example.com/api/http_proxies?search=location%3D+%22Default+Location%22 returns all
HTTP Proxies, even the ones that don't belong to the Default Location.

#4 - 02/19/2020 08:23 PM - lan Ballou
It appears that the SQL query for the HTTP Proxies is missing a
https://admin:changeme@centos7-katello-devel-stable.example.com/api/http_proxies?search=location%3D+%22Default+Location%22

AND taxable_type = 'HttpProxy'

on the line

ON "http_proxies"."id" = "taxable_taxonomies"."taxable_id"
Here is the SQL:

SELECT "http_proxies"."id" AS t0_r0, "http_proxies"."name" AS tO_rl, "http_proxies"."url" AS t0_r2, "http_prox

ies"."username" AS tO_r3, "http_proxies"."password" AS t0_r4, "taxonomies"."id" AS tl_r0, "taxonomies"."name"
AS tl_rl, "taxonomies"."type" AS tl_r2, "taxonomies"."created_at" AS tl_r3, "taxonomies"."updated_at" AS tl_r4
"taxonomies"."ignore_types" AS tl_r5, "taxonomies"."description" AS tl_r6, "taxonomies"."label" AS tl_r7, "t

axonomies"."ancestry" AS tl_r8, "taxonomies"."title" AS tl_r9, "taxonomies"."manifest_refreshed_at" AS tl_rl0
FROM "http_proxies" LEFT OUTER JOIN "taxable_taxonomies" ON "taxable_taxonomies"."taxable_id" = "http_proxies"
."id" AND "taxable_taxonomies"."taxable_type" = 'HttpProxy' LEFT OUTER JOIN "taxonomies" ON "taxonomies"."id"
= "taxable_taxonomies"."taxonomy_id" AND "taxonomies"."type" = 'Organization' WHERE (("http_proxies"."id" IN (
SELECT "http_proxies"."id" FROM "http_proxies"

INNER JOIN "taxable_taxonomies"

ON "http_proxies"."id" = "taxable_taxonomies"."taxable_id"

INNER JOIN "taxonomies"

ON "taxable_taxonomies"."taxonomy_id" = "taxonomies"."id"
WHERE "taxonomies"."name" = 'Default Organization' ))) ORDER BY http_proxies.name

Adding that SQL manually fixes the issue, but I'm not sure yet why it isn't being added. The SQL to search for Domain, for example, has that extra
SQLin it.

#5 - 02/21/2020 09:12 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/7458 added

#6 - 02/24/2020 02:56 PM - lan Ballou
- Blocked by Bug #29142: Delete all http proxies in test setup added

#7 - 02/24/2020 10:31 PM - The Foreman Bot
- Fixed in Releases 2.1.0 added

#8 - 02/24/2020 11:02 PM - Anonymous
- Status changed from Ready For Testing to Closed

Applied in changeset aObbfb283fee781ac3dba6f79703771a194af4ec.

#9 - 05/14/2020 07:23 AM - Amit Upadhye

- Category set to Organizations and Locations
